#ifndef	BYTE
#define BYTE            	char
#endif
#ifndef	CHAR
#define CHAR            	char
#endif
#ifndef	WORD
#define WORD            	short
#endif
#ifndef	LONG
#define LONG            	long
#endif
#ifndef	VOID
#define VOID            	void
#endif

#ifndef	TRUE
#define	TRUE			1
#endif
#ifndef	FALSE
#define	FALSE			0
#endif
#ifndef	ERROR
#define	ERROR			2
#endif
#ifndef ON
#define ON			1
#endif
#ifndef OFF
#define	OFF			0
#endif
#ifndef	YES
#define	YES			1
#endif
#ifndef	NO
#define	NO			0
#endif
#ifndef NULL
#define	NULL			0
#endif
#ifndef	BOOL
#define	BOOL			int
#endif
#ifndef NEGATIVE
#define NEGATIVE        	-1
#endif
#ifndef FOREVER
#define FOREVER         	for(;;)
#endif

#define	Debug			if(GBL_debug) fprintf

#ifndef	GLOBAL
#define	GLOBAL			extern
#endif

#define	XOR(a,b)		((!(a) && (b)) || ((a && !b)))

/* Wraparound defines:  note that i,j can be (i+ni), (i-ni), (j+nj), (j-nj)
   which allows the indices i,j to go either left or right in the image
   row */
#define	I(i,r)			(((r)+(i))%(r))
#define	J(j,c)			(((c)+(j))%(c))
#define	M2A(i,j,r,c)		(I((i),(r))*(c) + J((j),(c)))

/* Math constant PI, or use (4. * atan(1.)), or M_PI from math.h */

#define PI			3.1415926535897932384

#define STRSIZE			1024

/* Sequence */

#define	SEQ_START		101
#define	SEQ_END			102

/* Video source/sink bits:
   SRC_F_M  SNK_SCR  SNK_VID
         0        0        0	(impossible)		(initial value)
         0        1        0	(src: mem, snk: scr)
         0        0        1	(src: mem, snk: vid)
         0        1        1	(src: mem, snk: scr, vid)
         1        0        0	(impossible)
         1        1        0	(src: fil, snk: scr)
         1        0        1	(src: fil, snk: scr)
         1        1        1	(src: fil, snk: scr, vid)
*/

#define	VID_SRC_F_M		0x04
#define	VID_SNK_SCR		0x02
#define	VID_SNK_VID		0x01

/* Video source type: svideo or composite */

#define	VID_COMPST		200
#define	VID_SVIDEO		201

/* Scan (for interlaced video output) */

#define	ODD			1
#define	EVEN			0

/* R,G,B,A masks for picking out components from (long) data */
/* for ABGR format (obsolete)
#define	LONG_R_MASK		0x000000ff
#define LONG_G_MASK		0x0000ff00
#define LONG_B_MASK		0x00ff0000
#define LONG_A_MASK		0xff000000
*/
/* for RGBA format */
#define	LONG_R_MASK		0xff000000
#define LONG_G_MASK		0x00ff0000
#define LONG_B_MASK		0x0000ff00
#define LONG_A_MASK		0x000000ff

#define LONG_R(lval)		(((lval) & LONG_R_MASK)>>24);
#define LONG_G(lval)		(((lval) & LONG_G_MASK)>>16);
#define LONG_B(lval)		(((lval) & LONG_B_MASK)>>8);
#define LONG_A(lval)		(((lval) & LONG_A_MASK));

/* Integer defines for c3f() and c4f() color vector arrays */

#define	CVR			0
#define	CVG			1
#define	CVB			2
#define	CVA			3

/* Colormode (RGBmode or cmap), if(C_RGB) must evaluate TRUE */

#define	C_MAP			0
#define	C_RGB			1

/* Color indeces in range (0,255) reserved for grayscales */

#define	C_BLACK			0
#define	C_WHITE			255
#define	C_GREY25	(C_BLACK+(int)((float)(C_WHITE-C_BLACK+1)*(1./4.)))
#define	C_GREY30	(C_BLACK+(int)((float)(C_WHITE-C_BLACK+1)*(1./3.)))
#define	C_GREY50	(C_BLACK+(int)((float)(C_WHITE-C_BLACK+1)*(1./2.)))
#define	C_GREY60	(C_BLACK+(int)((float)(C_WHITE-C_BLACK+1)*(2./3.)))
#define	C_GREY75	(C_BLACK+(int)((float)(C_WHITE-C_BLACK+1)*(3./4.)))
#define	C_YELLOW		600
#define	C_CYAN			601
#define	C_GREEN			602
#define	C_MAGENTA		603
#define	C_RED			604
#define	C_BLUE			605
#define	C_SMPTE_WHITE		606
#define	C_SMPTE_YELLOW		607
#define	C_SMPTE_CYAN		608
#define	C_SMPTE_GREEN		609
#define	C_SMPTE_MAGENTA		610
#define	C_SMPTE_RED		611
#define	C_SMPTE_BLUE		612

/* Patches */

#define	P_BEZIER		1
#define	P_CARDINAL		2
#define	P_BSPLINE		3

/* Display modes */

#define GRFX_DISPLAY_WIRE	1
#define GRFX_DISPLAY_FACE	2
#define GRFX_DISPLAY_SMTH	3
#define GRFX_DISPLAY_PTCH	4
#define GRFX_DISPLAY_SGIF	5
#define GRFX_DISPLAY_SGIS	6

/* Polygon face orientation */

#define	POL_FRNT		0
#define	POL_BACK		1

/* BSP operatives */

#define BSP_INFRONT		0
#define BSP_BEHIND		1
#define	BSP_CUT			2
#define BSP_ONFACE		3

/* Background:  {color(C_BLACK): clear()} or use image */

#define	BKGND_BLK		0
#define	BKGND_IMG		1

/* Cursors */

#define	CURS_DEFAULT		0
#define	CURS_DNARROW		1
#define CURS_HOURGLS		2
#define	CURS_MARTINI		3

/* Keyboard bell durations */

#define	BELL_NONE		0
#define BELL_SHRT		1
#define BELL_LONG		2

/* Image size */

#define MAX_IMG_SIZE		32768
#define MAX_IMG_K		15

/* Display size */

#define DISP_OFST		10
#define DISP_SMLL		11
#define DISP_MIDD		12
#define DISP_NTSC		13
#define	DISP_LRGE		14
#define DISP_IMAG		15

/* Display mapping */

#define	DISP_IDWT		1
#define	DISP_MIPM		2

/* Mapping */

/*
#define HVS_D1			210
#define HVS_D2			410
#define HVS_D3			620
#define HVS_D4			830
#define HVS_D5			1050
*/
#define HVS_D1			105
#define HVS_D2			205
#define HVS_D3			310
#define HVS_D4			415
#define HVS_D5			525

/* distance ratios:  for efficiency, these have been hardcoded below
#define	HVS_D1_D2		((double)HVS_D2/(double)HVS_D1)
#define	HVS_D2_D3		((double)HVS_D3/(double)HVS_D2)
#define	HVS_D3_D4		((double)HVS_D4/(double)HVS_D3)
#define	HVS_D4_D5		((double)HVS_D5/(double)HVS_D4)

#define	HVS_D1_D3		((double)HVS_D2_D3*(double)HVS_D1_D2)
#define	HVS_D1_D4		((double)HVS_D3_D4*(double)HVS_D1_D3)
#define	HVS_D1_D5		((double)HVS_D4_D5*(double)HVS_D1_D4)
*/
#define	HVS_D1_D2		1.95238095238095238095
#define	HVS_D2_D3		1.51219512195121951219
#define	HVS_D3_D4		1.3387096774193548387
#define	HVS_D4_D5		1.26506024096385542168

#define HVS_D1_D3		2.95238095238095238095
#define	HVS_D1_D4		3.95238095238095238095
#define	HVS_D1_D5		5.00000000000000000000

/* Wavelets */

#define HAAR			1
#define MHAAR			2
#define DAUB4			3
#define DAUB6			4
#define GAB1			5
#define GAB3			6
#define QBSPL			7
#define BIOCDF			8
#define BIOLAP			9
#define BIOPT18			10
#define BIOQUAD			11
#define BIOATD			12
#define BIOSPL			13

/* Queue (qm) defs */

#ifndef USERBLOCK
#define	USERBLOCK		void
#endif

/* ROI Subband Weighting Function */

#define	ROI_SWF_GAU		1
#define	ROI_SWF_EXP		2
#define	ROI_SWF_BRN		3

/* Resolution mapping */

#define RES_HVS			1
#define RES_NLN			2
#define	RES_LIN			3

#define	RES_RECT		1
#define	RES_CIRC		2

/* ROI detection */

#define	ROI_DETECTION_AUTO	1
#define ROI_DETECTION_MANUAL	2

/* MENU selections */

#define	M_NSEL			-1
#define	M_SAVE			1
#define	M_LOAD			2
#define	M_VOIS_SAVE_2_IMG	3
#define	M_VOIS			3
#define	M_VOIS_LOAD_IMG		4
#define M_FONT			5
#define M_SAVE_PPM		110
#define M_SAVE_PGM		120
#define M_FONT_8_BY_13		210
#define M_FONT_9_BY_15		220
#define M_FONT_TR_10		230
#define M_FONT_TR_24		240
#define M_FONT_H_10		250
#define M_FONT_H_12		260
#define M_FONT_H_18		270

/* SMPTE color bar __positions__ (not actual colors or color indeces!)  */

#define	SMPTE_TOP_WHITE		0
#define	SMPTE_TOP_YELLOW	1
#define	SMPTE_TOP_CYAN		2
#define	SMPTE_TOP_GREEN		3
#define	SMPTE_TOP_MAGENTA	4
#define	SMPTE_TOP_RED		5
#define	SMPTE_TOP_BLUE		6

#define SMPTE_BOT_BLUE1		0
#define SMPTE_BOT_WHITE		1
#define	SMPTE_BOT_BLUE2		2
#define	SMPTE_BOT_BLACK1	3
#define	SMPTE_BOT_BLACK2	4

/* SMPTE colors (75% full colors), 32bit, ABGR encoding (AABBGGRR in hex) */

/* ABGR format (obsolete)
#define	SMPTE_BLACK_32		0xff000000
#define SMPTE_RED_32		0xff0000bf
#define SMPTE_GREEN_32		0xff00bf00
#define	SMPTE_YELLOW_32		0xff00bfbf
#define	SMPTE_BLUE_32		0xffbf0000
#define SMPTE_MAGENTA_32	0xffbf00bf
#define	SMPTE_CYAN_32		0xffbfbf00
#define	SMPTE_WHITE_32		0xffbfbfbf
#define	SMPTE_100WHITE_32	0xffffffff
*/
/* RGBA format */
#define	SMPTE_BLACK_32		0x000000ff
#define SMPTE_RED_32		0xbf0000ff
#define SMPTE_GREEN_32		0x00bf00ff
#define	SMPTE_YELLOW_32		0xbfbf00ff
#define	SMPTE_BLUE_32		0x0000bfff
#define SMPTE_MAGENTA_32	0xbf00bfff
#define	SMPTE_CYAN_32		0x00bfbfff
#define	SMPTE_WHITE_32		0xbfbfbfff
#define	SMPTE_100WHITE_32	0xffffffff

/* EFFECTIVE (TV) image range used for eye tracker calibration crosshairs

    720x480
    0,0 x ->
      +-----------------------------------------------------------+
    y |  60,60    60,180    60,300    60,420    60,540    60,660  |
    | | 180,60   180,180   180,300   180,420   180,540   180,660  |
    V | 300,60   300,180   300,300   300,420   300,540   300,660  |
      | 420,60   420,180   420,300   420,420   420,540   420,660  |
      +-----------------------------------------------------------+

    640x480
    0,0 x ->
      +----------------------------------------------------------+
    y | 50, 50   158, 50   266, 50   374, 50   482, 50   590, 50 |
    | | 50,142   158,142   266,142   374,142   482,142   590,142 |
    v | 50,234   158,234   266,234   374,234   482,234   590,234 |
      | 50,326   158,326   266,326   374,326   482,326   590,326 |
      | 50,418   158,418   266,418   374,418   482,418   590,418 |
      +----------------------------------------------------------+

#define TV_X_MIN	50
#define TV_X_MAX	590
#define TV_X_CLB_SEP	((TV_X_MAX - TV_X_MIN)/5)	 * 108 * 
#define TV_Y_MIN	50
#define TV_Y_MAX	418
#define TV_Y_CLB_SEP	((TV_Y_MAX - TV_Y_MIN)/4)	 * 92 * 

    640x480
    0,0 x ->
      +----------------------------------------------------------+
    y | 30, 30   146, 30   262, 30   378, 30   494, 30   610, 30 |
    | | 30,135   146,135   262,135   378,135   494,135   610,135 |
    v | 30,240   146,240   262,240   378,240   494,240   610,240 |
      | 30,345   146,345   262,345   378,345   494,345   610,345 |
      | 30,450   146,450   262,450   378,450   494,450   610,450 |
      +----------------------------------------------------------+
*/

#define	TV_ROWS		5
#define	TV_COLS		6

/*
#define TV_CPTS		30
#define TV_X_MIN	30
#define TV_X_MAX	610
#define TV_X_CLB_SEP	((TV_X_MAX - TV_X_MIN)/(TV_COLS - 1))
#define TV_Y_MIN	30
#define TV_Y_MAX	450
#define TV_Y_CLB_SEP	((TV_Y_MAX - TV_Y_MIN)/(TV_ROWS - 1))
#define TV_LSE_ALPHA1	6.98
#define	TV_LSE_ALPHA2	-21.42
#define TV_LSE_B11	1.33
#define TV_LSE_B12	0.00
#define TV_LSE_B21	0.00
#define TV_LSE_B22	2.00
*/

#define TV_CPTS		50
#define TV_X_MIN	50
#define TV_X_MAX	590
#define TV_X_CLB_SEP	((TV_X_MAX - TV_X_MIN)/(TV_COLS - 1))
#define TV_Y_MIN	50
#define TV_Y_MAX	418
#define TV_Y_CLB_SEP	((TV_Y_MAX - TV_Y_MIN)/(TV_ROWS - 1))
#define TV_LSE_ALPHA1	7.58
#define	TV_LSE_ALPHA2	-22.00
#define TV_LSE_B11	1.33
#define TV_LSE_B12	0.00
#define TV_LSE_B21	0.00
#define TV_LSE_B22	2.00
