#define PBM_WHITE 0
#define PBM_BLACK 1

#define PGM_MAXMAXVAL 255
#define PPM_MAXMAXVAL PGM_MAXMAXVAL

/* PBM Magic constants. */
#define PBM_MAGIC1 'P'
#define PBM_MAGIC2 '1'
#define RPBM_MAGIC2 '4'
#define PBM_FORMAT (PBM_MAGIC1 * 256 + PBM_MAGIC2)
#define RPBM_FORMAT (PBM_MAGIC1 * 256 + RPBM_MAGIC2)
#define PBM_TYPE PBM_FORMAT

/* PPM Magic constants. */
#define PPM_MAGIC1 'P'
#define PPM_MAGIC2 '3'
#define RPPM_MAGIC2 '6'
#define PPM_FORMAT (PPM_MAGIC1 * 256 + PPM_MAGIC2)
#define RPPM_FORMAT (PPM_MAGIC1 * 256 + RPPM_MAGIC2)
#define PPM_TYPE PPM_FORMAT

/* PGM Magic constants. */
#define PGM_MAGIC1 'P'
#define PGM_MAGIC2 '2'
#define RPGM_MAGIC2 '5'
#define PGM_FORMAT (PGM_MAGIC1 * 256 + PGM_MAGIC2)
#define RPGM_FORMAT (PGM_MAGIC1 * 256 + RPGM_MAGIC2)
#define PGM_TYPE PGM_FORMAT

/* Macro for turning a format number into a type number. */
#define PBM_FORMAT_TYPE(f) ((f) == PBM_FORMAT || (f) == RPBM_FORMAT ? PBM_TYPE : -1)

/* Macro for turning a format number into a type number. */
#define PPM_FORMAT_TYPE(f) ((f) == PPM_FORMAT || (f) == RPPM_FORMAT ? PPM_TYPE : PGM_FORMAT_TYPE(f))

/* Macro for turning a format number into a type number. */
#define PGM_FORMAT_TYPE(f) ((f) == PGM_FORMAT || (f) == RPGM_FORMAT ? PGM_TYPE : PBM_FORMAT_TYPE(f))

typedef unsigned char gray;
typedef unsigned char bit;
typedef unsigned char byte;
typedef struct {
	int	rows;		/* rows */
	int	cols;		/* cols */
	int	format;		/* format */
	gray	maxval;		/* maxval */
} PNMheader_struct, PPMheader_struct, PGMheader_struct, *PNMheader, *PPMheader, *PGMheader;

void	P_pnm_putus(ushort n, FILE *fp);
int 	P_pnm_getint(FILE *fp);
char 	P_pnm_getc(FILE *fp);
byte 	P_pnm_getrawbyte(FILE *fp);
bit 	P_pnm_getbit(FILE *fp);
